@echo off
call copy_dlls.bat > nul

echo ------ test mysql query : -----------------------------------------------------

start "mysql40" /B "%MYSQL_40_PATH%\bin\mysqld-nt.exe" --port=3307
start "mysql41" /B "%MYSQL_41_PATH%\bin\mysqld-nt.exe" --port=3308

call check.bat simple_select_user mysql40 "simple select_user         on mysql-4.0                              "
call check.bat simple_select_user mysql41 "simple select_user         on mysql-4.1                              "

call check.bat is_editable        mysql41 "is editable                on mysql-4.1                              "
call check.bat native             mysql41 "native queries             on mysql-4.1                              "

call check.bat swap_clauses       mysql41 "swap clauses               on mysql-4.1                              "
call check.bat large_select       mysql41 "select from list of tables on mysql-4.1                              "

call check.bat quote_no           mysql41 "queries without quotas     on mysql-4.1                              "
call check.bat quote_mysql        mysql41 "queries with mysql quotas  on mysql-4.1                              "
call check.bat quote_ansi         mysql41 "queries with ansi quotas   on mysql-4.1                              "

rem call check.bat mysql-test-run-4.1 mysql41 "full sql log from             mysql-4.1                              " clauses_permutation

start "mysql40 stop" /B "%MYSQL_40_PATH%\bin\mysqladmin.exe" --user=root --port=3307 shutdown
start "mysql41 stop" /B "%MYSQL_41_PATH%\bin\mysqladmin.exe" --user=root --port=3308 shutdown

echo ------ test mysql query with ansi quotas : ------------------------------------

start "mysql41" /B "%MYSQL_41_PATH%\bin\mysqld-nt.exe" --port=3308 --sql_mode=ansi_quote

call check.bat quote_no           mysql41_ansi "queries without quotas     on mysql-4.1                              "
call check.bat quote_mysql        mysql41_ansi "queries with mysql quotas  on mysql-4.1                              "
call check.bat quote_ansi         mysql41_ansi "queries with ansi quotas   on mysql-4.1                              "

start "mysql41 stop" /B "%MYSQL_41_PATH%\bin\mysqladmin.exe" --user=root --port=3308 shutdown

echo -------------------------------------------------------------------------------
call clear_dlls.bat > nul
