@echo off
call copy_dlls.bat > nul

echo ------ test mysql query composition : -----------------------------------------

start "mysql41" /B "%MYSQL_41_PATH%\bin\mysqld-nt.exe" --port=3308
start "mysql" /B "%MYSQL_41_PATH%\bin\mysql.exe" --user=root --port=3308 < t/prepare_innodb.sql

call check.bat create_new_query           mysql41 "simple new query                     on mysql-4.1                    "
call check.bat quoted_names               mysql41 "using name to quote                  on mysql-4.1                    "
call check.bat using_schema               mysql41 "using schema in table name           on mysql-4.1                    "
call check.bat select_add                 mysql41 "add table to select list             on mysql-4.1                    "
call check.bat select_left_outer_join     mysql41 "add left outer join table to select  on mysql-4.1                    "
call check.bat select_join                mysql41 "add table to select                  on mysql-4.1                    "
call check.bat select_join_without_where  mysql41 "add table to select without where    on mysql-4.1                    "
call check.bat test_query_without_aliases mysql41 "test query with aliasless tables     on mysql-4.1                    "

call check.bat add_column_from            mysql41 "add column from                      on mysql-4.1                    "
call check.bat add_column_select          mysql41 "add column select                    on mysql-4.1                    "
call check.bat add_column_where           mysql41 "add column where                     on mysql-4.1                    "
call check.bat add_column_group           mysql41 "add column group                     on mysql-4.1                    "
call check.bat add_column_having          mysql41 "add column having                    on mysql-4.1                    "
call check.bat add_column_order           mysql41 "add column order                     on mysql-4.1                    "
call check.bat add_column_set             mysql41 "add column set                       on mysql-4.1                    "

call check.bat add_column_to_empty        mysql41 "add column to empty query            on mysql-4.1                    "
call check.bat test_aliases               mysql41 "test aliases assignment              on mysql-4.1                    "

call check.bat innodb_relations           mysql41 "test innodb relations                on mysql-4.1                    "

call check.bat using_complex_names        mysql41 "test complex names                   on mysql-4.1                    "

start "mysql41 stop" /B "%MYSQL_41_PATH%\bin\mysqladmin.exe" --user=root --port=3308 shutdown
start "mysql41" /B "%MYSQL_41_PATH%\bin\mysqld-nt.exe" --port=3308 --sql_mode=ansi_quote

call check.bat using_complex_names        mysql41_ansi "test complex names with ansi mode    on mysql-4.1                    "

start "mysql" /B "%MYSQL_41_PATH%\bin\mysql.exe" --user=root --port=3308 < t/clean_innodb.sql
start "mysql41 stop" /B "%MYSQL_41_PATH%\bin\mysqladmin.exe" --user=root --port=3308 shutdown

echo -------------------------------------------------------------------------------
call clear_dlls.bat > nul
